﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using WpfApplication1;
using System.Collections.ObjectModel;
using System.ComponentModel;

namespace WpfApplication1
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            var sqlData = new List<SqlDataDto> 
                  { 
                      new SqlDataDto {Id = 1, ParentId = null, Name = "F1"} 
                      , new SqlDataDto {Id = 2, ParentId = null, Name = "F2"} 
                      , new SqlDataDto {Id = 3, ParentId = 1, Name = "S1"} 
                      , new SqlDataDto {Id = 4, ParentId = 2, Name = "S21"} 
                      , new SqlDataDto {Id = 5, ParentId = 2, Name = "S22"}
                      , new SqlDataDto {Id = 6, ParentId = 5, Name = "Parent Id=5"} //THIS NODE IS NOT BEING CREATED!
                      , new SqlDataDto {Id = 7, ParentId = 6, Name = "Parent Id=6"} //THIS NODE IS NOT BEING CREATED!
                  };
            treeView.ItemsSource = GetHerachy(sqlData); 

        }

        public List<LocalData> GetHerachy(List<SqlDataDto> sqlData)
        {
            var sqlParents = sqlData.Where(q => q.ParentId == null).ToList();
            var parents = sqlParents.Select(q => new LocalData { Id = q.Id, Name = q.Name }).ToList();
            foreach (var parent in parents)
            {
                var childs = sqlData.Where(q => q.ParentId == parent.Id).Select(q => new LocalData { Id = q.Id, Name = q.Name, Parent = parent });
                parent.Children = new ObservableCollection<LocalData>(childs);
            }
            return parents;
        } 
    }



}
